angular.module('app.services', [])

.factory('SongBDFactory', function($rootScope,$q,SongArray){
	var songDB={};
	
	var songArray = SongArray.items;
	

	songDB.init = function  () {
		if ($rootScope.db.version == "") {
			$rootScope.db.changeVersion("", "1",populateDB,errorCB,successCB);
			console.log('changeVersion 1');
		} else if ($rootScope.db.version == "1") {
			$rootScope.db.transaction(queryFavoritesNumbers, errorCB);
			$rootScope.db.changeVersion("1", "2",version2BD,errorCB.successCB);
			console.log('changeVersion 2');
		}else if ($rootScope.db.version == "2") {
			$rootScope.db.transaction(queryFavoritesNumbers, errorCB);
			$rootScope.db.changeVersion("2", "3",version2BD,errorCB,successCB);
			console.log('changeVersion 3');
		}else if ($rootScope.db.version == "3") {
			$rootScope.db.transaction(queryFavoritesNumbers, errorCB);
			$rootScope.db.changeVersion("3", "4",version2BD,errorCB,successCB);
			console.log('changeVersion 4');
		}
		else if ($rootScope.db.version == "4") {
			$rootScope.db.transaction(queryFavoritesNumbers, errorCB);
			$rootScope.db.changeVersion("4", "5",version2BD,errorCB,successCB);
			console.log('changeVersion 5');
		}
		else if ($rootScope.db.version == "5") {
			$rootScope.db.transaction(queryFavoritesNumbers, errorCB);
			$rootScope.db.changeVersion("5", "6",version2BD,errorCB,successCB);
		}
	}

	function populateDB(tx) {
    	tx.executeSql('CREATE TABLE IF NOT EXISTS tbl_songs (number INTEGER PRIMARY KEY AUTOINCREMENT, title VARCHAR(50), favorite VARCHAR(2), score VARCHAR(2), theme VARCHAR(50),lyrics VARCHAR(2500))');
    	for (var k = 0; k < songArray.length; k++) {
        	tx.executeSql('INSERT INTO tbl_songs (number,title,favorite,score, theme, lyrics) VALUES ('+songArray[k][0]+',"'+songArray[k][1]+'","'+songArray[k][2]+'","'+songArray[k][3]+'","'+songArray[k][4]+'","'+songArray[k][5]+'")',[],successCB,errorCB);
    	console.log('populateDB');}

	}

	function version2BD(tx) {
		console.log('version2BD');
    	tx.executeSql('DROP TABLE IF EXISTS tbl_songs');
    	tx.executeSql('CREATE TABLE IF NOT EXISTS tbl_songs (number INTEGER PRIMARY KEY AUTOINCREMENT, title VARCHAR(50), favorite VARCHAR(2), score VARCHAR(2),  theme VARCHAR(50),lyrics VARCHAR(2500))');
     	for (var k = 0; k < songArray.length; k++) {
        	tx.executeSql('INSERT INTO tbl_songs (number,title,favorite,score, theme, lyrics) VALUES ('+songArray[k][0]+',"'+songArray[k][1]+'","'+songArray[k][2]+'","'+songArray[k][3]+'","'+songArray[k][4]+'","'+songArray[k][5]+'")',[],successCB,errorCB);
    	}
	}

	function queryFavoritesNumbers(tx) {
    	tx.executeSql('SELECT number, favorite FROM tbl_songs', [], querySuccessFavoritesNumbers, errorCB);
	}
	function querySuccessFavoritesNumbers(tx, results) {
    	var len = results.rows.length;
    	for (var i=0; i<len; i++){
        	var song = results.rows.item(i);
			songArray[i][2]=song.favorite;
		}
	}

	songDB.getSong = function  (number) {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	tx.executeSql('SELECT number,title,lyrics,favorite,theme FROM tbl_songs where number=:number', [number], 
		 		function  (tx, results) {
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		 			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	} 

	songDB.getSongFromNumber = function  (number) {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	tx.executeSql('SELECT number,title,theme,lyrics,favorite FROM tbl_songs where number=?', [number], 
		 		function  (tx, results) {
		 			
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		 			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	} 

	songDB.getSongsFromLetter = function  (letter) {
		letter = letter+'%';
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	tx.executeSql('SELECT number,title,theme,lyrics,favorite FROM tbl_songs where title like ? ORDER BY title asc', [letter], 
		 		function  (tx, results) {
		 			
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		 			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	} 

	songDB.getSongsThemes = function  () {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
			tx.executeSql('SELECT DISTINCT theme FROM tbl_songs',[], 
		 		function  (tx, results) {
		 			console.log(results.rows.item(3).theme);
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		  			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	}

	songDB.getSongAlphas = function  () {
			var deferred = $q.defer();
		 	$rootScope.db.transaction( function  (tx) {
				tx.executeSql('SELECT number, title FROM tbl_songs where title like ? ORDER BY title asc', [letter], 
			 		function  (tx, results) {
			 			//console.log(results.rows.item(3).theme);
			 			deferred.resolve(results);
			 		}, function (tx, error) {
			  			deferred.reject (error);
			 		} 
			 	);
			});
			return deferred.promise;	
		}

	
	songDB.getSongsFromTheme = function  (theme) {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
			tx.executeSql('SELECT  number,favorite,theme,title FROM tbl_songs WHERE theme =? ',[theme], 
		 		function  (tx, results) {
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		  			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	}

	songDB.searchSongs = function  (string) {
		var deferred = $q.defer();
		string  = '%'+string+'%';
		console.log(string);
		$rootScope.db.transaction( function  (tx) {
			tx.executeSql('SELECT  number,title FROM tbl_songs where title like ?',[string], 
		 		function  (tx, results) {
		 			deferred.resolve(results);
		 		}, function (tx, error) {
		  			deferred.reject (error);
		 		} 
		 	);
		});
		return deferred.promise;	
	}

	songDB.getFavoritesSongs = function  () {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	tx.executeSql('SELECT number, title, favorite FROM tbl_songs where favorite=1', [],
			 	function  (tx, results) {
			 		deferred.resolve(results);
			 		console.log(results);
			 	}, function (tx, error) {
			 		deferred.reject (error);
			 	}
			); 
		});
		return deferred.promise;
	}

	songDB.addFavoriteSong = function  (number) {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	 tx.executeSql('Update tbl_songs set favorite=1 where number=:number', [number],
			 	function  (tx, results) {
			 		deferred.resolve(results);
			 	}, function (tx, error) {
			 		deferred.reject (error);
			 	}
			); 
		});
		return deferred.promise;
	}

	songDB.removeFavoriteSong = function  (number) {
		var deferred = $q.defer();
		$rootScope.db.transaction( function  (tx) {
		 	 tx.executeSql('Update tbl_songs set favorite=0 where number=:number', [number],
			 	function  (tx, results) {
			 		deferred.resolve(results);
			 	}, function (tx, error) {
			 		deferred.reject (error);
			 	}
			); 
		});
		return deferred.promise;
	}


	function errorCB(err) {
    	console.log("Error processing SQL: "+err.message);
	}
	function successCB() {
    console.log('success bds')
  
}

	return songDB;
})


.service('AudioSvc', [function() {

  var AudioSvc = {
    my_media: null,
    mediaTimer: null,
    playAudio: function(src, cb) {
      var self = this;

      // stop playing, if playing
      self.stopAudio();

      self.my_media = new Media(src, onSuccess, onError);
      self.my_media.play();

      if (self.mediaTimer == null) {
        self.mediaTimer = setInterval(function() {
          self.my_media.getCurrentPosition(
            function(position) {
              cb(position, self.my_media.getDuration());
            },
            function(e) {
              console.log("Error getting pos=" + e);
            }
          );
        }, 1000);
      }

      function onSuccess() {
        console.log("playAudio():Audio Success");
      }

      // onError Callback
      //
      function onError(error) {
        // alert('code: ' + error.code + '\n' +
        //     'message: ' + error.message + '\n');

        // we forcefully stop

      }

    },

    resumeAudio: function() {
      var self = this;
      if (self.my_media) {
        self.my_media.play();
      }
    },
    pauseAudio: function() {
      var self = this;
      if (self.my_media) {
        self.my_media.pause();
      }
    },
    stopAudio: function() {
      var self = this;
      if (self.my_media) {
        self.my_media.stop();
      }
      if (self.mediaTimer) {
        clearInterval(self.mediaTimer);
        self.mediaTimer = null;
      }
    }

  };

  return AudioSvc;
}])



.service('BlankService', [function(){

}]);

